/*
 * KlappBuch.java
 *
 * Created on 10. Mai 2003, 09:20
 */

package Aufgabe;
import java.awt.BorderLayout;
import java.awt.Frame;
import java.awt.event.*;
import java.awt.GraphicsConfiguration;
import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.universe.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import java.awt.event.*;
import java.awt.AWTEvent;
import java.util.Enumeration;
import com.sun.j3d.utils.behaviors.keyboard.*;
import com.sun.j3d.utils.behaviors.picking.*;
import com.sun.j3d.utils.behaviors.mouse.*;
import com.sun.j3d.utils.picking.*;

/**                        TransformGroup tg 
                                    |
                          Wurzel (TF Ebene Legen)
 *               /            |                  \                        
 *     TGBuchBodenPos     TGBuchPapierPos         TGBuchDeckelPos          
            |                  |                        |
        BuchBoden           BuchPapier           tgBuchDeckelRotate 
 *                                                      |
 *                                            tgBuchDeckelAusZentrumPos 
 *                                                      |
 *                                                   BuchDeckel
 *                              
 */
public class KlappBuch {
  
  Locale         m_Locale;
  TransformGroup m_Wurzel;
  Canvas3D       m_Canvas;
  
  final Point3d origin = new Point3d(0.0d,0.0d,0.0d); 
  
 
  
  public KlappBuch(TransformGroup tg, Canvas3D canvas, Locale locale) {
      m_Canvas = canvas;
      m_Locale = locale;
      
      Shader weiss = new Shader();
        weiss.setColor(220,220,220,Shader.DIFFUSE);
      Shader braun = new Shader();
        braun.setColor(166,118,73,Shader.DIFFUSE);
      Shader texbuchDeckel = new Shader();
        texbuchDeckel.setColor(220,220,220,Shader.DIFFUSE);
        texbuchDeckel.mitTextur("Deckel.jpg");
      Shader texPapier = new Shader();
        texPapier.setColor(220,220,220,Shader.DIFFUSE);
        texPapier.mitTextur("Papier.jpg");
        
      Box BuchBoden  = new Box(0.35f,0.5f,0.025f,braun.getAppearance());
        Transform3D tfBuchBodenPos = new Transform3D();
        tfBuchBodenPos.set(new Vector3f(-0.2f,0.0f,-0.05f));
        TransformGroup tgBuchBodenPos = new TransformGroup(tfBuchBodenPos);
        tgBuchBodenPos.addChild(BuchBoden);

      Box BuchPapier = new Box(0.33f,0.475f,0.1f,Box.GENERATE_TEXTURE_COORDS | Box.GENERATE_NORMALS,weiss.getAppearance());
        BuchPapier.getShape(1).setAppearance(texPapier.getAppearance());
        Transform3D tfBuchPapierPos = new Transform3D();
        tfBuchPapierPos.set(new Vector3f(-0.22f,0.0f,-0.17f));
        TransformGroup tgBuchPapierPos = new TransformGroup(tfBuchPapierPos);
        tgBuchPapierPos.addChild(BuchPapier);
     
      Box BuchDeckel  = new Box(0.35f,0.5f,0.025f,Box.GENERATE_TEXTURE_COORDS | Box.GENERATE_NORMALS 
        ,braun.getAppearance());
      BuchDeckel.getShape(1).setAppearance(texbuchDeckel.getAppearance());
      BuchDeckel.setCapability(Box.ALLOW_PICKABLE_WRITE);
      BuchDeckel.setCapability(Box.ALLOW_PICKABLE_READ);
      BuchDeckel.setCapability(Box.ENABLE_PICK_REPORTING);
      BuchDeckel.setCapability(Box.ENABLE_GEOMETRY_PICKING);
      
   
      //Deckel Position
      Transform3D tfBuchDeckelPos = new Transform3D();
      tfBuchDeckelPos.set(new Vector3f(-0.55f,0.0f,-0.25f));
      TransformGroup tgBuchDeckelPos = new TransformGroup(tfBuchDeckelPos);
       
      //Pick Behaviorm ginzufgen
      MeinPick mp = new MeinPick(m_Canvas, m_Locale, BuchDeckel);
      mp.setSchedulingBounds(new BoundingSphere(origin,1000.0d));
                   
      //Fr die DeckelRotation  TransformGroup vorbereiten       
      Transform3D tfRot = new Transform3D();
      TransformGroup tgBuchDeckelRotate = new TransformGroup(tfRot);
      tgBuchDeckelRotate.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
      tgBuchDeckelRotate.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
       
       // Behavior erstellen fr die beiden 
      OeffneBehavior     oeffneDeckel    = new OeffneBehavior(tgBuchDeckelRotate,mp);   //mp fr post mitgeben
      SchliesseBehavior  schliesseDeckel = new SchliesseBehavior(tgBuchDeckelRotate,mp);

       //damit sie sich gegenseitig benachrichtigen knnen
      oeffneDeckel.setBehaviorObjectPartner(schliesseDeckel);
      schliesseDeckel.setBehaviorObjectPartner(oeffneDeckel);


       // Scheduling Bounds
      BoundingSphere bounds = new BoundingSphere();
      oeffneDeckel.setSchedulingBounds(bounds);
      schliesseDeckel.setSchedulingBounds(bounds);
     
      //Deckel aus Zentrum
      Transform3D tfBuchDeckelAusZentrumPos = new Transform3D();
      tfBuchDeckelAusZentrumPos.set(new Vector3f(0.35f,0.0f,-0.03f));  
      TransformGroup tgBuchDeckelAusZentrumPos = new  TransformGroup(tfBuchDeckelAusZentrumPos);
         
      //Hierarchie erstellen
      tgBuchDeckelPos.addChild(tgBuchDeckelRotate);
      tgBuchDeckelAusZentrumPos.addChild(BuchDeckel);
      tgBuchDeckelRotate.addChild(tgBuchDeckelAusZentrumPos);
            
      //Alles auf Ebene legen und diese etwas drehen      
      Transform3D tfEbeneLegen = new Transform3D();
      Transform3D tfDrehen = new Transform3D();
      tfDrehen.rotZ(Buch3D.GradInBogen(-10));
      tfEbeneLegen.rotX(Buch3D.GradInBogen(90));
      tfEbeneLegen.mul(tfDrehen);
     
      m_Wurzel = new TransformGroup(tfEbeneLegen);    
      m_Wurzel.addChild(tgBuchBodenPos);
      m_Wurzel.addChild(tgBuchPapierPos);
      m_Wurzel.addChild(tgBuchDeckelPos);
      m_Wurzel.addChild(oeffneDeckel);
      m_Wurzel.addChild(schliesseDeckel);
      m_Wurzel.addChild(mp);
      tg.addChild(m_Wurzel);
  }
    
}
